/*
 * Copyright (c) 2001, Adam Dunkels.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Adam Dunkels.
 * 4. The name of the author may not be used to endorse or promote
 *    products derived from this software without specific prior
 *    written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * This file is part of the uIP TCP/IP stack.
 *
 * $Id: main.c,v 1.16 2006/06/11 21:55:03 adam Exp $
 *
 */

// *********************************************************************
// Define the IP address to be used for the MCU running the TCP/IP stack
// *********************************************************************



#include "globals.h"
char kktest[100];
//#define ip32bit(a,b,c,d) a<<24|b<<16|c<<8|d

volatile char ledtest=0;
char kksend_len;
char kksend_status=0;

//__BSS(RAM2)
//__attribute__ ((section(".myBuffer"))) char ybuf[30000];


#include "LPC17xx.h"
#include "LPC176x.h"
#include "pinout.h"
#include "defines.c"

#include "spi_ssp.h"
#include "rtc.h"
#include "start.h" //void SysTick_Handler (void) doppelt
#include "string.h"

#define cortex_m3x 1
#include "colors.h"
#include "new_ili9320.h"
#include "new_lib_fonts.h"
#include "new_lib_glcd.h"
#include "kklcdxx.h"
#include "touch.h"
#include "uart176x.h"

//++++++++++++++++ fatsd
#include "mmc_ssp.h"
#include "ff.h"
#include "startfat.h"
#include "kk_sd.h"
FATFS fs;         // Work area (file system object) for logical drive //
FIL fsrc;         // file objects //
FRESULT res;
UINT br;
char path[512]="0:";
int SD_TotalSize(void);
void USART_Configuration(void);
FRESULT scan_files (char* path);
//---------------- fatsd ------------------------
//++++++++++++++++  net  ++++++++++++++++++++++++
#include "network_config.h"
#include "lpc17xx_emac.h"
#include "networkdevice.h"
#include "networkdevicec.h"
#include "stack.h"
#include "stackc.h"
#include "udp.h"
#include "ntp.h"
#include "ntpc.h"
#include "telnetd.h"
#include "telnetdc.h"
#include "dnsc.h"
#include "dnscc.h"
#include "httpd.h"
#include "webpage.h"
#include "xstring.h"
#include "httpdc.h"
//----------------  net  ------------------------

//#include "dhcpc.h"

#include <cr_section_macros.h>
#include <NXP/crp.h>
// Variable to store CRP value in. Will be placed automatically
// by the linker when "Enable Code Read Protect" selected.
// See crp.h header for more information
__CRP const unsigned int CRP_WORD = CRP_NO_CRP ;

void AnzeigeArpTable(void){
/*	uint_8 i;
	 for(i=0;i<5;i++){
	lcd_goto(7+i,1);
	 //abfr=arp_entry[i].arp_t_mac;
	 //lcd_hex8(abfr>>24);lcd_hex8(abfr>>16);lcd_hex8(abfr>>8);lcd_hex8(abfr);
	memcpy(tmp_mac,arp_entry[i].arp_t_mac,6);
	  //  					for(j=0;j<6;j++)lcd_hex8(tmp_mac[j]);
	lcd_hex8(tmp_mac[1]);lcd_hex8(tmp_mac[5]);lw("-");

	arp_entry[i].arp_t_ip;
	 lcd_hex8(abfr>>24);
	 //lcd_hex8(abfr>>16);lcd_hex8(abfr>>8);
	 lcd_hex8(abfr);
	 lw("-");
	li(arp_entry[i].arp_t_time);
	}//for
	for(i=0;i<3;i++){
	lcd_goto(12+i,1);
	abfr=tcp_entry[i].ip;
	 lcd_hex8(abfr>>24);
	 //lcd_hex8(abfr>>16);lcd_hex8(abfr>>8);
	 lcd_hex8(abfr);
		lw("-");
	li(tcp_entry[i].src_port);lw("-");
	li(tcp_entry[i].dest_port);lw("-");
	li(tcp_entry[i].status);lw("-");
	li(tcp_entry[i].time);lw("-");

	}//for
	*/
}		//+++ Display MYIP_4 - Aktivitäten
/*if ((kktest[80]!=0 )&&(kktest[23]==17||kktest[23]==6||kktest[23]==1)){
	lgw(9,1, "source: ");li(kktest[26]);lw(".");li(kktest[27]);lw(".");li(kktest[28]);lw(".");li(kktest[29]);lw(" ");li(sec);
	lgw(10,1,"dest:   ");li(kktest[30]);lw(".");li(kktest[31]);lw(".");li(kktest[32]);lw(".");li(kktest[33]);lw(".");
	lgw(11,1,"prot:   ");li(kktest[23]);lw(" ");
	lgw(12,1,"sport:   ");li(kktest[34]<<8|kktest[35]);lw(" ");
	lgw(13,1,"dport:   ");li(kktest[36]<<8|kktest[37]);lw(" ");
	lgw(14,1,"payload: ");
for(i=0;i<4;i++){
lgi(15+i,1,kktest[42+i*5]);lw(",");li(kktest[43+i*5]);lw(",");li(kktest[44+i*5]);lw(",");li(kktest[45+i*5]);lw(",");li(kktest[46+i*5]);lw(",");
}
kktest[80]=0;}*/




void AnzeigePing(void){
lcd_goto(2,1);
lcd_write("Ping von: ");
lcd_ip;
clr1(fPING);
set1(fANZEIGE);
timer_Anzeige=15;
}

/*--------------------------- main ---------------------------------*/
//extern uip_sappdata;
char ipstring [20];
//volatile u8 hsec;
int main(void)
{
	unsigned int i;

	init_led();
	lcd_init();
	lcd_clear(DKRED);
	interrupt_pins_init();//1+2+4
	vF_SysTickInit(100000000, 10);
	rtc_init();
	rtc_int_init();
	tast_pin_init(0,10);
	uart0_init();
	//	 out_pin_init(1,18);
	//	 __enable_irq();
//+++++++++++++ sd ++++++++++++++++++
	res=f_mount(0, &fs);
	mp3_anz_verzeichnisse=fat_subdirselect(99);
	fat_subdirshow(5,8);
//------------- sd ------------------


__enable_irq();

u8 x=0,xsec,zl,zl2=1,sec_alt,zl3,j;
u32 abfr;
//+++++++++ ethernet init

//unsigned int packet_lenght;
set1(fNTP);
set1(fDNS_IP);
networkdevice_init();
udp_init();
ntp_init();
telnetd_init();
dns_init();
dns_query(hostname);
httpd_init();

unsigned char b[5];
//			uint8_t *x;
http_entry[1].new_page_pointer=Page1;
b[0] = pgm_read_bytex(http_entry[1].new_page_pointer++);
b[1] = pgm_read_bytex(http_entry[1].new_page_pointer++);
b[2] = pgm_read_bytex(http_entry[1].new_page_pointer++);
b[3] = pgm_read_bytex(http_entry[1].new_page_pointer++);
b[4] = '\0';
lgw(10,1,b);




//==================================================================
while(1){
//+++++++++ polling ++++++++++
eth_get_data();
//--------- polling ----------
//++++++++++++ sec +++++++++++++
if(sec_alt!=SEC && timer_netactivity==0){ sec_alt=SEC;xsec++; lcd_goto(1,7);lcd_int2(SEC);//li(timerDrehzahl);
//============ sec++ ===========
//++jede sec
if_f(fAnzeigeArpTcp){AnzeigeArpTable();}
if_f(fANZEIGE){if(!timer_Anzeige){lgw(2,1,"                   ");clr1(fANZEIGE);}}
if_f(fPING){AnzeigePing();}
if_f(fNTP){ntp_request();}
if_f(fDNS_IP){dns_query(hostname);}


//++++++++++++ min ++++++++++++++++++
if((SEC==0|| gbi(bool_menu, mn_programmstart)==0)){lcd_goto(1,1);lcd_int2(hou);lw(":");lcd_int2(min);lw(":");
//------------ min ------------------

//+++++++++ volle Stunde
if(min==0){
set1(fDNS_IP);//flag setzen
}//-------- volle Stunde


//+++++++++++ check Sommerzeit ++++++++
if((HOUR==3&&MIN<5 )|| gbi(bool_menu, mn_programmstart)==0){
auto_sommerzeit();
sbi(bool_menu, mn_programmstart);
}//hou=3
//----------- check Sommerzeit --------
}//--- min ----
}//--- sec++ --
}//while
}//main
