//#define lcd_modus   0// =>AVR/spi
#define lcd_modus 1// =>LPC/ssp
//#define lcd_modus 2// =>LPC/8bit 
//#define lcd_modus 3// =>STM/16bit 

#if lcd_modus==1
#define CSB_PORT_NUM	0
#define CSB_PIN_NUM		16

#define cs_lcd_off    pinCLR(CSB_PORT_NUM,CSB_PIN_NUM)
#define cs_lcd_on     pinSET(CSB_PORT_NUM,CSB_PIN_NUM)

#define lcd_spi_init lcd_ssp_init
//=================================================
void lcd_ssp_init(void){
//0.15 0.17 0.18 ssp0/F x10
	pinSEL(0,16,0);
	pinDIRout(0,16);
	pinSET(0,16);

//	init_ssp0_1();
//hw_spi_init();
	pinSEL(0,15,0b11);//0.15-4:ck
	pinSEL(0,17,0b11);//0.17-4:miso
	pinSEL(0,18,0b11);//0.18-4:mosi
//	PINSEL0|=(3<<30);//0.15-4:ck
//	 PINSEL1|=(3<<2);//0.17-4:miso
//	 PINSEL1|=(3<<4);//0.18-4:mosi
//	 PINSEL1  = 0b111100; // P0.18 = MOSI, P0.17 = MISO, P0.16 = GPIO
	pinMODE(0,15,mode_non);
	pinMODE(0,16,mode_non);
	pinMODE(0,17,mode_non);
	pinMODE(0,18,mode_non);
//	PINMODE0 = 2<<30;    // P0.15 has neither pull-up nor pull-down
//	 PINMODE1 = 0b101010; // P0.18..16 have neither pull-up nor pull-down
	#define BitEnablehwspi 0
	#define MSTRhwspi 5
	#define CPOLhwspi 4
	#define CPHAhwspi 3
	#define SPIFhwspi 7
	S0SPCR=(1<<MSTRhwspi);
	S0SPCR&=~(1<<BitEnablehwspi);//
	S0SPCR|=(1<<CPOLhwspi);// S0SPCR|=(1<<CPOL);//
	S0SPCR|=(1<<CPHAhwspi);//
	S0SPCCR=8;
}
//=================================================

void spi_write(uint8_t dat){
//ssp0_write(dat);
xlpc_spi_rd_wr(dat);
}
//=================================================
xlpc_spi_rd_wr(dat){
	S0SPDR=dat;
	while(!(S0SPSR & (1<<7)));//SPIF=7
	//return(S0SPDR);
}

#endif



#define lcd_max_width 320
#define lcd_min_width 240


//#define DISP_ORIENTATION  0 //0x0� screen rotation
#define DISP_ORIENTATION  1 //1x90� screen rotation
//#define DISP_ORIENTATION  2 //2x180� screen rotation
//#define DISP_ORIENTATION  3 //3x270� screen rotation


//==========================================================
//==========================================================

#if lcd_modus==0//spi

#define hw_spi 1// o_sw 1_hw

#define sck_lcd_port		B
#define sck_lcd_pin				7
#define miso_lcd_port		B
#define miso_lcd_pin			6
#define mosi_lcd_port		B
#define mosi_lcd_pin			5
#define cs_lcd_port			B
#define cs_lcd_pin				4

#define sck_lcd_on  sbi(PORT(sck_lcd_port),sck_lcd_pin)
#define sck_lcd_off cbi(PORT(sck_lcd_port),sck_lcd_pin)
#define mosi_lcd_on  sbi(PORT(mosi_lcd_port),mosi_lcd_pin)
#define mosi_lcd_off cbi(PORT(mosi_lcd_port),mosi_lcd_pin)
#define cs_lcd_on  sbi(PORT(cs_lcd_port),cs_lcd_pin)
#define cs_lcd_off cbi(PORT(cs_lcd_port),cs_lcd_pin)

void lcd_spi_init(void){
sbi(DDR(cs_lcd_port),cs_lcd_pin);
sbi(DDR(sck_lcd_port),sck_lcd_pin);
sbi(DDR(mosi_lcd_port),mosi_lcd_pin);
cbi(DDR(miso_lcd_port),miso_lcd_pin);
#if hw_spi
SPCR=(1<<SPE)|(1<<MSTR);
SPCR|=(1<<CPOL);// 
SPCR|=(1<<CPHA);//
SPSR = (1 << SPI2X);  // maximale Geschwindigkeit: F_CPU / 2 

#endif
_delay_ms(50);


#define spi_modus 1
//#define LCD_RS {//}
}



void spi_write (unsigned char byte_s)
{SPDR=byte_s;
while(!(SPSR & (1<<SPIF)));
}

u8 spi_read(u8 x) {
SPDR=x;
while(!(SPSR & (1<<SPIF)));
return(SPDR);
}
#endif

#if lcd_modus==2
#define wr_8bit ;
#define wr_8bit {LCD_WR(0);LCD_WR(1);}
#endif

//===========================================================



#if  ( DISP_ORIENTATION == 1 ) || ( DISP_ORIENTATION == 3 )
//querformat landscape
#define  MAX_X  lcd_max_width
#define  MAX_Y  lcd_min_width   
#elif  ( DISP_ORIENTATION == 0 ) || ( DISP_ORIENTATION == 2 )
//hochformat portrait
#define  MAX_X  lcd_min_width
#define  MAX_Y  lcd_max_width   
#endif

//==============================================================

#define adr_index  	    0x70                                               
#define adr_command		0x72
#define null 			0
//==============================================================


void  lcd_write_index(u8 dat){
cs_lcd_off;
spi_write(adr_index);
spi_write(null);
spi_write(dat);
cs_lcd_on;
}

void  lcd_write_data(u16 dat){
cs_lcd_off;
spi_write(adr_command);
spi_write(dat>>8);
spi_write(dat&0xff);
cs_lcd_on;
}

 void LCD_Write_Data_Start(void)
{
  spi_write(adr_command);    /* Write : RS = 1, RW = 0       */
}

void  lcd_write_data_only(u16 dat){
spi_write(dat>>8);
spi_write(dat&0xff);
}

void  lcd_write_reg(u8 index, u16 dat){
lcd_write_index(index);
lcd_write_data(dat);
}

void lcd_init(void)
{
//	unsigned short DeviceCode;
	
//	LCD_Configuration();
lcd_spi_init();
//ili_reset();

//	DeviceCode = LCD_ReadReg(0x0000);		/* Read ID	*/	
	/* Different driver IC initialization*/
//	if( DeviceCode == 0x9320 || DeviceCode == 0x9300 )
//	{
		lcd_write_reg(0x00,0x0000);
		lcd_write_reg(0x01,0x0100); /* Driver Output Contral */
		lcd_write_reg(0x02,0x0700); /* LCD Driver Waveform Contral */


//old		lcd_write_reg(0x03,0x1038); /* Set the scan mode */
		//Portrait//landscape

#if ( DISP_ORIENTATION == 0 )//0� grad
		lcd_write_reg(0x0003,(1<<12) ); 	/* importance */
#endif
#if ( DISP_ORIENTATION == 1 )//90�
		lcd_write_reg(0x0003,(1<<12)|(1<<5)|(1<<3) ); 	/* importance */
#endif
#if ( DISP_ORIENTATION == 2 )//180�
		lcd_write_reg(0x0003,(1<<12)|(1<<4)|(1<<5) ); 	/* importance */
#endif
#if ( DISP_ORIENTATION == 3 )//270�
		lcd_write_reg(0x0003,(1<<12)|(1<<4)|(1<<3) ); 	/* importance */
#endif

		lcd_write_reg(0x04,0x0000); /* Scalling Contral */
		lcd_write_reg(0x08,0x0202); /* Display Contral 2 */
		lcd_write_reg(0x09,0x0000); /* Display Contral 3 */
		lcd_write_reg(0x0a,0x0000); /* Frame Cycle Contal */
		lcd_write_reg(0x0c,(1<<0)); /* Extern Display Interface Contral 1 */
		lcd_write_reg(0x0d,0x0000); /* Frame Maker Position */
		lcd_write_reg(0x0f,0x0000); /* Extern Display Interface Contral 2 */     
		_delay_ms(50); 
		lcd_write_reg(0x07,0x0101); /* Display Contral */
		_delay_ms(50);    
		lcd_write_reg(0x10,(1<<12)|(0<<8)|(1<<7)|(1<<6)|(0<<4)); /* Power Control 1 */
		lcd_write_reg(0x11,0x0007);                              /* Power Control 2 */
		lcd_write_reg(0x12,(1<<8)|(1<<4)|(0<<0));                /* Power Control 3 */
		lcd_write_reg(0x13,0x0b00);                              /* Power Control 4 */
		lcd_write_reg(0x29,0x0000);                              /* Power Control 7 */
		lcd_write_reg(0x2b,(1<<14)|(1<<4)); 
	
		lcd_write_reg(0x50,0);       /* Set X Start */
		lcd_write_reg(0x51,239);	    /* Set X End */
		lcd_write_reg(0x52,0);	    /* Set Y Start */
		lcd_write_reg(0x53,319);	    /* Set Y End */
		_delay_ms(50);

		lcd_write_reg(0x60,0x2700); /* Driver Output Control */
		lcd_write_reg(0x61,0x0001); /* Driver Output Control */
		lcd_write_reg(0x6a,0x0000); /* Vertical Srcoll Control */
		
		lcd_write_reg(0x80,0x0000); /* Display Position? Partial Display 1 */
		lcd_write_reg(0x81,0x0000); /* RAM Address Start? Partial Display 1 */
		lcd_write_reg(0x82,0x0000); /* RAM Address End-Partial Display 1 */
		lcd_write_reg(0x83,0x0000); /* Displsy Position? Partial Display 2 */
		lcd_write_reg(0x84,0x0000); /* RAM Address Start? Partial Display 2 */
		lcd_write_reg(0x85,0x0000); /* RAM Address End? Partial Display 2 */
		
		lcd_write_reg(0x90,(0<<7)|(16<<0)); /* Frame Cycle Contral */
		lcd_write_reg(0x92,0x0000);         /* Panel Interface Contral 2 */
		lcd_write_reg(0x93,0x0001);         /* Panel Interface Contral 3 */
		lcd_write_reg(0x95,0x0110);         /* Frame Cycle Contral */
		lcd_write_reg(0x97,(0<<8)); 
		lcd_write_reg(0x98,0x0000);         /* Frame Cycle Contral */    
		lcd_write_reg(0x07,0x0133); 
//	}		
    _delay_ms(100);   /* delay 50 ms */		
}

//==================================================
void lcd_setcursor(uint16_t Xpos,uint16_t Ypos){
//
	uint16_t i=Xpos;
#if ( DISP_ORIENTATION == 0 )//0� grad
			Xpos=MAX_X-Xpos;
			Ypos=MAX_Y-Ypos;
#endif
#if ( DISP_ORIENTATION == 1 )//0� grad
			Xpos=MAX_Y-Ypos;
			Ypos=i;
#endif
#if ( DISP_ORIENTATION == 2 )//0� grad
			//Xpos=Xpos;
			//Ypos=MAX_Y-Ypos;
#endif
#if ( DISP_ORIENTATION == 3 )//0� grad
			Xpos=Ypos;
			Ypos=MAX_X-i;
#endif

lcd_write_reg(0x0020, Xpos );
lcd_write_reg(0x0021, Ypos );
}
//==================================================
void lcd_pixel(uint16_t Xpos,uint16_t Ypos,uint16_t color)
{
	if( Xpos >= MAX_X || Ypos >= MAX_Y )
	{
		return;
	}
	lcd_setcursor(Xpos,Ypos);
	lcd_write_reg(0x0022,color);
}

//==================================================


void lcd_clear(uint16_t Color){
	uint32_t index=0;
	lcd_setcursor(0,0);
	lcd_write_index(0x0022);

 	cs_lcd_off;
	LCD_Write_Data_Start();
	for( index = 0; index < ((uint32_t)lcd_max_width*lcd_min_width); index++ )	{
		lcd_write_data_only(Color);
	}
	cs_lcd_on;
}

//==================================================

void lcd_ClearZeilen_Y(u16 y_anf,u16 y_end, u16 Color)               
{	
	uint32_t index=0;
	lcd_setcursor(0,y_anf);
	lcd_write_index(0x0022);

 	cs_lcd_off;
	LCD_Write_Data_Start();
	for( index = 0; index < ((uint32_t)MAX_X*(y_end-y_anf)); index++ )	{
		lcd_write_data_only(Color);
	}
	cs_lcd_on;
}

//==================================================

